Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4108)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4109)
@@ -3275,5 +3505,5 @@
 !--    calculated explicetely for the tendency at
 !--    the first w-level. For topography wall this is done implicitely by
-!--    advc_flags_1.
+!--    advc_flags_m.
        k         = nzb + 1
        w_comp(k) = w(k,j,i) + w(k-1,j,i)
@@ -3285,24 +3515,24 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit35 = REAL( IBITS(advc_flags_2(k,j,i),3,1), KIND = wp )
-          ibit34 = REAL( IBITS(advc_flags_2(k,j,i),2,1), KIND = wp )
-          ibit33 = REAL( IBITS(advc_flags_2(k,j,i),1,1), KIND = wp )
-
-          k_ppp = k + 3 * ibit35
-          k_pp  = k + 2 * ( 1 - ibit33  )
-          k_mm  = k - 2 * ibit35
+          ibit26 = REAL( IBITS(advc_flags_m(k,j,i),26,1), KIND = wp )
+          ibit25 = REAL( IBITS(advc_flags_m(k,j,i),25,1), KIND = wp )
+          ibit24 = REAL( IBITS(advc_flags_m(k,j,i),24,1), KIND = wp )
+
+          k_ppp = k + 3 * ibit26
+          k_pp  = k + 2 * ( 1 - ibit24  )
+          k_mm  = k - 2 * ibit26
 
           w_comp(k) = w(k+1,j,i) + w(k,j,i)
           flux_t(k) = w_comp(k) * rho_air(k+1) * (                            &
-                     ( 37.0_wp * ibit35 * adv_mom_5                           &
-                  +     7.0_wp * ibit34 * adv_mom_3                           &
-                  +              ibit33 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i)  + w(k,j,i)     )                &
-              -      (  8.0_wp * ibit35 * adv_mom_5                           &
-                  +              ibit34 * adv_mom_3                           &
+                     ( 37.0_wp * ibit26 * adv_mom_5                           &
+                  +     7.0_wp * ibit25 * adv_mom_3                           &
+                  +              ibit24 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( w(k+1,j,i)   + w(k,j,i)    )                &
+              -      (  8.0_wp * ibit26 * adv_mom_5                           &
+                  +              ibit25 * adv_mom_3                           &
                      ) *                                                      &
                                 ( w(k_pp,j,i)  + w(k-1,j,i)  )                &
-              +      (           ibit35 * adv_mom_5                           &
+              +      (           ibit26 * adv_mom_5                           &
                      ) *                                                      &
                                 ( w(k_ppp,j,i) + w(k_mm,j,i) )                &
@@ -3310,14 +3540,14 @@
 
           diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                   &
-                     ( 10.0_wp * ibit35 * adv_mom_5                           &
-                  +     3.0_wp * ibit34 * adv_mom_3                           &
-                  +              ibit33 * adv_mom_1                           &
+                     ( 10.0_wp * ibit26 * adv_mom_5                           &
+                  +     3.0_wp * ibit25 * adv_mom_3                           &
+                  +              ibit24 * adv_mom_1                           &
                      ) *                                                      &
                                 ( w(k+1,j,i)   - w(k,j,i)    )                &
-              -      (  5.0_wp * ibit35 * adv_mom_5                           &
-                  +              ibit34 * adv_mom_3                           &
+              -      (  5.0_wp * ibit26 * adv_mom_5                           &
+                  +              ibit25 * adv_mom_3                           &
                      ) *                                                      &
                                 ( w(k_pp,j,i)  - w(k-1,j,i)  )                &
-              +      (           ibit35 * adv_mom_5                           &
+              +      (           ibit26 * adv_mom_5                           &
                      ) *                                                      &
                                 ( w(k_ppp,j,i) - w(k_mm,j,i) )                &
@@ -3327,37 +3557,37 @@
        DO  k = nzb+3, nzt-2
        
-          ibit35 = REAL( IBITS(advc_flags_2(k,j,i),3,1), KIND = wp )
-          ibit34 = REAL( IBITS(advc_flags_2(k,j,i),2,1), KIND = wp )
-          ibit33 = REAL( IBITS(advc_flags_2(k,j,i),1,1), KIND = wp )
+          ibit26 = REAL( IBITS(advc_flags_m(k,j,i),26,1), KIND = wp )
+          ibit25 = REAL( IBITS(advc_flags_m(k,j,i),25,1), KIND = wp )
+          ibit24 = REAL( IBITS(advc_flags_m(k,j,i),24,1), KIND = wp )
 
           w_comp(k) = w(k+1,j,i) + w(k,j,i)
           flux_t(k) = w_comp(k) * rho_air(k+1) * (                            &
-                     ( 37.0_wp * ibit35 * adv_mom_5                           &
-                  +     7.0_wp * ibit34 * adv_mom_3                           &
-                  +              ibit33 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i)  + w(k,j,i)     )                &
-              -      (  8.0_wp * ibit35 * adv_mom_5                           &
-                  +              ibit34 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( w(k+2,j,i)  + w(k-1,j,i)  )                 &
-              +      (           ibit35 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( w(k+3,j,i) + w(k-2,j,i) )                   &
+                     ( 37.0_wp * ibit26 * adv_mom_5                           &
+                  +     7.0_wp * ibit25 * adv_mom_3                           &
+                  +              ibit24 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( w(k+1,j,i)  + w(k,j,i)   )                  &
+              -      (  8.0_wp * ibit26 * adv_mom_5                           &
+                  +              ibit25 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( w(k+2,j,i)  + w(k-1,j,i) )                  &
+              +      (           ibit26 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( w(k+3,j,i)  + w(k-2,j,i) )                  &
                                                  )
 
           diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                   &
-                     ( 10.0_wp * ibit35 * adv_mom_5                           &
-                  +     3.0_wp * ibit34 * adv_mom_3                           &
-                  +              ibit33 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i)   - w(k,j,i)    )                &
-              -      (  5.0_wp * ibit35 * adv_mom_5                           &
-                  +              ibit34 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( w(k+2,j,i)  - w(k-1,j,i)  )                 &
-              +      (           ibit35 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( w(k+3,j,i) - w(k-2,j,i) )                   &
+                     ( 10.0_wp * ibit26 * adv_mom_5                           &
+                  +     3.0_wp * ibit25 * adv_mom_3                           &
+                  +              ibit24 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( w(k+1,j,i) - w(k,j,i)    )                  &
+              -      (  5.0_wp * ibit26 * adv_mom_5                           &
+                  +              ibit25 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( w(k+2,j,i) - w(k-1,j,i)  )                  &
+              +      (           ibit26 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( w(k+3,j,i) - w(k-2,j,i)  )                  &
                                                           )
        ENDDO
@@ -3367,24 +3597,24 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit35 = REAL( IBITS(advc_flags_2(k,j,i),3,1), KIND = wp )
-          ibit34 = REAL( IBITS(advc_flags_2(k,j,i),2,1), KIND = wp )
-          ibit33 = REAL( IBITS(advc_flags_2(k,j,i),1,1), KIND = wp )
-
-          k_ppp = k + 3 * ibit35
-          k_pp  = k + 2 * ( 1 - ibit33  )
-          k_mm  = k - 2 * ibit35
+          ibit26 = REAL( IBITS(advc_flags_m(k,j,i),26,1), KIND = wp )
+          ibit25 = REAL( IBITS(advc_flags_m(k,j,i),25,1), KIND = wp )
+          ibit24 = REAL( IBITS(advc_flags_m(k,j,i),24,1), KIND = wp )
+
+          k_ppp = k + 3 * ibit26
+          k_pp  = k + 2 * ( 1 - ibit24  )
+          k_mm  = k - 2 * ibit26
 
           w_comp(k) = w(k+1,j,i) + w(k,j,i)
           flux_t(k) = w_comp(k) * rho_air(k+1) * (                            &
-                     ( 37.0_wp * ibit35 * adv_mom_5                           &
-                  +     7.0_wp * ibit34 * adv_mom_3                           &
-                  +              ibit33 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i)  + w(k,j,i)     )                &
-              -      (  8.0_wp * ibit35 * adv_mom_5                           &
-                  +              ibit34 * adv_mom_3                           &
+                     ( 37.0_wp * ibit26 * adv_mom_5                           &
+                  +     7.0_wp * ibit25 * adv_mom_3                           &
+                  +              ibit24 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( w(k+1,j,i)   + w(k,j,i)    )                &
+              -      (  8.0_wp * ibit26 * adv_mom_5                           &
+                  +              ibit25 * adv_mom_3                           &
                      ) *                                                      &
                                 ( w(k_pp,j,i)  + w(k-1,j,i)  )                &
-              +      (           ibit35 * adv_mom_5                           &
+              +      (           ibit26 * adv_mom_5                           &
                      ) *                                                      &
                                 ( w(k_ppp,j,i) + w(k_mm,j,i) )                &
@@ -3392,14 +3622,14 @@
 
           diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                   &
-                     ( 10.0_wp * ibit35 * adv_mom_5                           &
-                  +     3.0_wp * ibit34 * adv_mom_3                           &
-                  +              ibit33 * adv_mom_1                           &
+                     ( 10.0_wp * ibit26 * adv_mom_5                           &
+                  +     3.0_wp * ibit25 * adv_mom_3                           &
+                  +              ibit24 * adv_mom_1                           &
                      ) *                                                      &
                                 ( w(k+1,j,i)   - w(k,j,i)    )                &
-              -      (  5.0_wp * ibit35 * adv_mom_5                           &
-                  +              ibit34 * adv_mom_3                           &
+              -      (  5.0_wp * ibit26 * adv_mom_5                           &
+                  +              ibit25 * adv_mom_3                           &
                      ) *                                                      &
                                 ( w(k_pp,j,i)  - w(k-1,j,i)  )                &
-              +      (           ibit35 * adv_mom_5                           &
+              +      (           ibit26 * adv_mom_5                           &
                      ) *                                                      &
                                 ( w(k_ppp,j,i) - w(k_mm,j,i) )                &
@@ -3412,42 +3642,42 @@
           diss_d    = diss_t(k-1)
           
-          ibit29 = REAL( IBITS(advc_flags_1(k,j,i),29,1), KIND = wp )
-          ibit28 = REAL( IBITS(advc_flags_1(k,j,i),28,1), KIND = wp )
-          ibit27 = REAL( IBITS(advc_flags_1(k,j,i),27,1), KIND = wp )
+          ibit20 = REAL( IBITS(advc_flags_m(k,j,i),20,1), KIND = wp )
+          ibit19 = REAL( IBITS(advc_flags_m(k,j,i),19,1), KIND = wp )
+          ibit18 = REAL( IBITS(advc_flags_m(k,j,i),18,1), KIND = wp )
           
-          ibit32 = REAL( IBITS(advc_flags_2(k,j,i),0,1),  KIND = wp )
-          ibit31 = REAL( IBITS(advc_flags_1(k,j,i),31,1), KIND = wp )
-          ibit30 = REAL( IBITS(advc_flags_1(k,j,i),30,1), KIND = wp )
+          ibit23 = REAL( IBITS(advc_flags_m(k,j,i),23,1), KIND = wp )
+          ibit22 = REAL( IBITS(advc_flags_m(k,j,i),22,1), KIND = wp )
+          ibit21 = REAL( IBITS(advc_flags_m(k,j,i),21,1), KIND = wp )
           
-          ibit35 = REAL( IBITS(advc_flags_2(k,j,i),3,1), KIND = wp )
-          ibit34 = REAL( IBITS(advc_flags_2(k,j,i),2,1), KIND = wp )
-          ibit33 = REAL( IBITS(advc_flags_2(k,j,i),1,1), KIND = wp )
+          ibit26 = REAL( IBITS(advc_flags_m(k,j,i),26,1), KIND = wp )
+          ibit25 = REAL( IBITS(advc_flags_m(k,j,i),25,1), KIND = wp )
+          ibit24 = REAL( IBITS(advc_flags_m(k,j,i),24,1), KIND = wp )
 !
 !--       Calculate the divergence of the velocity field. A respective
 !--       correction is needed to overcome numerical instabilities introduced
 !--       by a not sufficient reduction of divergences near topography.
-          div = ( ( ( u_comp(k) + gu ) * ( ibit27 + ibit28 + ibit29 )         &
+          div = ( ( ( u_comp(k) + gu ) * ( ibit18 + ibit19 + ibit20 )         &
                   - ( u(k+1,j,i) + u(k,j,i)   )                               & 
                                     * (                                       &
-                     REAL( IBITS(advc_flags_1(k,j,i-1),27,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j,i-1),28,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j,i-1),29,1), KIND = wp )     &
+                     REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k,j,i-1),19,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k,j,i-1),20,1), KIND = wp )     &
                                       )                                       &
                   ) * ddx                                                     &
-              +   ( ( v_comp(k) + gv ) * ( ibit30 + ibit31 + ibit32 )         & 
+              +   ( ( v_comp(k) + gv ) * ( ibit21 + ibit22 + ibit23 )         & 
                   - ( v(k+1,j,i) + v(k,j,i)   )                               &
                                     * (                                       &
-                     REAL( IBITS(advc_flags_1(k,j-1,i),30,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j-1,i),31,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_2(k,j-1,i),0,1),  KIND = wp )     &
+                     REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k,j-1,i),22,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k,j-1,i),23,1), KIND = wp )     &
                                       )                                       &
                   ) * ddy                                                     &
               +   ( w_comp(k)               * rho_air(k+1)                    &
-                                            * ( ibit33 + ibit34 + ibit35 )    &
+                                            * ( ibit24 + ibit25 + ibit26 )    &
                 - ( w(k,j,i) + w(k-1,j,i) ) * rho_air(k)                      &
                                     * (                                       &
-                     REAL( IBITS(advc_flags_2(k-1,j,i),1,1), KIND = wp )      &
-                   + REAL( IBITS(advc_flags_2(k-1,j,i),2,1), KIND = wp )      &
-                   + REAL( IBITS(advc_flags_2(k-1,j,i),3,1), KIND = wp )      &
+                     REAL( IBITS(advc_flags_m(k-1,j,i),24,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k-1,j,i),25,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k-1,j,i),26,1), KIND = wp )     &
                                       )                                       & 
                   ) * drho_air_zw(k) * ddzu(k+1)                              &
@@ -3531,19 +3761,28 @@
 !> Scalar advection - Call for all grid points
 !------------------------------------------------------------------------------!
-    SUBROUTINE advec_s_ws( sk, sk_char )
+    SUBROUTINE advec_s_ws( advc_flag, sk, sk_char,                             &
+                           non_cyclic_l, non_cyclic_n,                         &
+                           non_cyclic_r, non_cyclic_s )
 
 
        CHARACTER (LEN = *), INTENT(IN)    ::  sk_char !< string identifier, used for assign fluxes to the correct dimension in the analysis array 
-       INTEGER(iwp) ::  sk_num !< integer identifier, used for assign fluxes to the correct dimension in the analysis array
+       INTEGER(iwp) ::  sk_num = 0 !< integer identifier, used for assign fluxes to the correct dimension in the analysis array
        
-       INTEGER(iwp) ::  i         !< grid index along x-direction
-       INTEGER(iwp) ::  j         !< grid index along y-direction
-       INTEGER(iwp) ::  k         !< grid index along z-direction
-       INTEGER(iwp) ::  k_mm      !< k-2 index in disretization, can be modified to avoid segmentation faults
-       INTEGER(iwp) ::  k_pp      !< k+2 index in disretization, can be modified to avoid segmentation faults
-       INTEGER(iwp) ::  k_ppp     !< k+3 index in disretization, can be modified to avoid segmentation faults
-       INTEGER(iwp) ::  nzb_max_l !< index indicating upper bound for order degradation of horizontal advection terms 
-       INTEGER(iwp) ::  tn = 0    !< number of OpenMP thread
+       INTEGER(iwp) ::  i          !< grid index along x-direction
+       INTEGER(iwp) ::  j          !< grid index along y-direction
+       INTEGER(iwp) ::  k          !< grid index along z-direction
+       INTEGER(iwp) ::  k_mm       !< k-2 index in disretization, can be modified to avoid segmentation faults
+       INTEGER(iwp) ::  k_pp       !< k+2 index in disretization, can be modified to avoid segmentation faults
+       INTEGER(iwp) ::  k_ppp      !< k+3 index in disretization, can be modified to avoid segmentation faults
+       INTEGER(iwp) ::  nzb_max_l  !< index indicating upper bound for order degradation of horizontal advection terms 
+       INTEGER(iwp) ::  tn = 0     !< number of OpenMP thread
        
+       INTEGER(iwp), INTENT(IN), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::   &
+                                                  advc_flag !< flag array to control order of scalar advection
+                                                  
+       LOGICAL ::  non_cyclic_l    !< flag that indicates non-cyclic boundary on the left
+       LOGICAL ::  non_cyclic_n    !< flag that indicates non-cyclic boundary on the north
+       LOGICAL ::  non_cyclic_r    !< flag that indicates non-cyclic boundary on the right
+       LOGICAL ::  non_cyclic_s    !< flag that indicates non-cyclic boundary on the south  
 !       
 !--    sk is an array from parameter list. It should not be a pointer, because 
@@ -3552,5 +3791,5 @@
 !--    even worse, because the compiler cannot assume strided one in the 
 !--    caller side.
-       REAL(wp), INTENT(IN),DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !<  advected scalar
+       REAL(wp), INTENT(IN), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !<  advected scalar
 
        REAL(wp) ::  ibit0  !< flag indicating 1st-order scheme along x-direction
@@ -3612,8 +3851,6 @@
 !--    entire subdomain, in order to avoid unsymmetric loops which might be 
 !--    an issue for GPUs.
-       IF( bc_dirichlet_l  .OR.  bc_radiation_l  .OR.                          &
-           bc_dirichlet_r  .OR.  bc_radiation_r  .OR.                          &
-           bc_dirichlet_s  .OR.  bc_radiation_s  .OR.                          &
-           bc_dirichlet_n  .OR.  bc_radiation_n )  THEN
+       IF( non_cyclic_l  .OR.  non_cyclic_r  .OR.                             &
+           non_cyclic_s  .OR.  non_cyclic_n )  THEN
           nzb_max_l = nzt
        ELSE
@@ -3652,7 +3889,7 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit2 = REAL( IBITS(advc_flags_1(k,j,i-1),2,1), KIND = wp )
-             ibit1 = REAL( IBITS(advc_flags_1(k,j,i-1),1,1), KIND = wp )
-             ibit0 = REAL( IBITS(advc_flags_1(k,j,i-1),0,1), KIND = wp )
+             ibit2 = REAL( IBITS(advc_flag(k,j,i-1),2,1), KIND = wp )
+             ibit1 = REAL( IBITS(advc_flag(k,j,i-1),1,1), KIND = wp )
+             ibit0 = REAL( IBITS(advc_flag(k,j,i-1),0,1), KIND = wp )
 
              u_comp                 = u(k,j,i) - u_gtrans + u_stokes_zu(k)
@@ -3719,5 +3956,5 @@
        !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
        !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s) &
-       !$ACC PRESENT(advc_flags_1) &
+       !$ACC PRESENT(advc_flag) &
        !$ACC PRESENT(sk, u, v, w, u_stokes_zu, v_stokes_zu) &
        !$ACC PRESENT(drho_air, rho_air_zw, ddzw) &
@@ -3736,7 +3973,7 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit5 = REAL( IBITS(advc_flags_1(k,j-1,i),5,1), KIND = wp )
-             ibit4 = REAL( IBITS(advc_flags_1(k,j-1,i),4,1), KIND = wp )
-             ibit3 = REAL( IBITS(advc_flags_1(k,j-1,i),3,1), KIND = wp )
+             ibit5 = REAL( IBITS(advc_flag(k,j-1,i),5,1), KIND = wp )
+             ibit4 = REAL( IBITS(advc_flag(k,j-1,i),4,1), KIND = wp )
+             ibit3 = REAL( IBITS(advc_flag(k,j-1,i),3,1), KIND = wp )
 
              v_comp               = v(k,j,i) - v_gtrans + v_stokes_zu(k)
@@ -3798,7 +4035,7 @@
              DO  k = nzb+1, nzb_max_l
 
-                ibit2 = REAL( IBITS(advc_flags_1(k,j,i),2,1), KIND = wp )
-                ibit1 = REAL( IBITS(advc_flags_1(k,j,i),1,1), KIND = wp )
-                ibit0 = REAL( IBITS(advc_flags_1(k,j,i),0,1), KIND = wp )
+                ibit2 = REAL( IBITS(advc_flag(k,j,i),2,1), KIND = wp )
+                ibit1 = REAL( IBITS(advc_flag(k,j,i),1,1), KIND = wp )
+                ibit0 = REAL( IBITS(advc_flag(k,j,i),0,1), KIND = wp )
 
                 u_comp = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
@@ -3836,7 +4073,7 @@
 !
 !--             Recompute the left fluxes.
-                ibit2_l = REAL( IBITS(advc_flags_1(k,j,i-1),2,1), KIND = wp )
-                ibit1_l = REAL( IBITS(advc_flags_1(k,j,i-1),1,1), KIND = wp )
-                ibit0_l = REAL( IBITS(advc_flags_1(k,j,i-1),0,1), KIND = wp )
+                ibit2_l = REAL( IBITS(advc_flag(k,j,i-1),2,1), KIND = wp )
+                ibit1_l = REAL( IBITS(advc_flag(k,j,i-1),1,1), KIND = wp )
+                ibit0_l = REAL( IBITS(advc_flag(k,j,i-1),0,1), KIND = wp )
 
                 u_comp_l = u(k,j,i) - u_gtrans + u_stokes_zu(k)
@@ -3875,7 +4112,7 @@
 #endif
 
-                ibit5 = REAL( IBITS(advc_flags_1(k,j,i),5,1), KIND = wp )
-                ibit4 = REAL( IBITS(advc_flags_1(k,j,i),4,1), KIND = wp )
-                ibit3 = REAL( IBITS(advc_flags_1(k,j,i),3,1), KIND = wp )
+                ibit5 = REAL( IBITS(advc_flag(k,j,i),5,1), KIND = wp )
+                ibit4 = REAL( IBITS(advc_flag(k,j,i),4,1), KIND = wp )
+                ibit3 = REAL( IBITS(advc_flag(k,j,i),3,1), KIND = wp )
 
                 v_comp = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
@@ -3913,7 +4150,7 @@
 !
 !--             Recompute the south fluxes.
-                ibit5_s = REAL( IBITS(advc_flags_1(k,j-1,i),5,1), KIND = wp )
-                ibit4_s = REAL( IBITS(advc_flags_1(k,j-1,i),4,1), KIND = wp )
-                ibit3_s = REAL( IBITS(advc_flags_1(k,j-1,i),3,1), KIND = wp )
+                ibit5_s = REAL( IBITS(advc_flag(k,j-1,i),5,1), KIND = wp )
+                ibit4_s = REAL( IBITS(advc_flag(k,j-1,i),4,1), KIND = wp )
+                ibit3_s = REAL( IBITS(advc_flag(k,j-1,i),3,1), KIND = wp )
 
                 v_comp_s = v(k,j,i) - v_gtrans + v_stokes_zu(k)
@@ -3955,7 +4192,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit8 = REAL( IBITS(advc_flags_1(k,j,i),8,1), KIND = wp )
-                ibit7 = REAL( IBITS(advc_flags_1(k,j,i),7,1), KIND = wp )
-                ibit6 = REAL( IBITS(advc_flags_1(k,j,i),6,1), KIND = wp )
+                ibit8 = REAL( IBITS(advc_flag(k,j,i),8,1), KIND = wp )
+                ibit7 = REAL( IBITS(advc_flag(k,j,i),7,1), KIND = wp )
+                ibit6 = REAL( IBITS(advc_flag(k,j,i),6,1), KIND = wp )
 
                 k_ppp = k + 3 * ibit8
@@ -3998,14 +4235,14 @@
                 div   =   ( u(k,j,i+1) * ( ibit0 + ibit1 + ibit2 )             &
                           - u(k,j,i)   * (                                     &
-                        REAL( IBITS(advc_flags_1(k,j,i-1),0,1), KIND = wp )    &
-                      + REAL( IBITS(advc_flags_1(k,j,i-1),1,1), KIND = wp )    &
-                      + REAL( IBITS(advc_flags_1(k,j,i-1),2,1), KIND = wp )    &
+                        REAL( IBITS(advc_flag(k,j,i-1),0,1), KIND = wp )       &
+                      + REAL( IBITS(advc_flag(k,j,i-1),1,1), KIND = wp )       &
+                      + REAL( IBITS(advc_flag(k,j,i-1),2,1), KIND = wp )       &
                                          )                                     &
                           ) * ddx                                              &
                         + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )             &
                           - v(k,j,i)   * (                                     &
-                        REAL( IBITS(advc_flags_1(k,j-1,i),3,1), KIND = wp )    &
-                      + REAL( IBITS(advc_flags_1(k,j-1,i),4,1), KIND = wp )    &
-                      + REAL( IBITS(advc_flags_1(k,j-1,i),5,1), KIND = wp )    &
+                        REAL( IBITS(advc_flag(k,j-1,i),3,1), KIND = wp )       &
+                      + REAL( IBITS(advc_flag(k,j-1,i),4,1), KIND = wp )       &
+                      + REAL( IBITS(advc_flag(k,j-1,i),5,1), KIND = wp )       &
                                          )                                     &
                           ) * ddy                                              &
@@ -4014,7 +4251,7 @@
                           - w(k-1,j,i) * rho_air_zw(k-1) *                     &
                                          (                                     &
-                        REAL( IBITS(advc_flags_1(k-1,j,i),6,1), KIND = wp )    &
-                      + REAL( IBITS(advc_flags_1(k-1,j,i),7,1), KIND = wp )    &
-                      + REAL( IBITS(advc_flags_1(k-1,j,i),8,1), KIND = wp )    &
+                        REAL( IBITS(advc_flag(k-1,j,i),6,1), KIND = wp )       &
+                      + REAL( IBITS(advc_flag(k-1,j,i),7,1), KIND = wp )       &
+                      + REAL( IBITS(advc_flag(k-1,j,i),8,1), KIND = wp )       &
                                          )                                     &      
                           ) * drho_air(k) * ddzw(k)
@@ -4202,7 +4439,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit8 = REAL( IBITS(advc_flags_1(k,j,i),8,1), KIND = wp )
-                ibit7 = REAL( IBITS(advc_flags_1(k,j,i),7,1), KIND = wp )
-                ibit6 = REAL( IBITS(advc_flags_1(k,j,i),6,1), KIND = wp )
+                ibit8 = REAL( IBITS(advc_flag(k,j,i),8,1), KIND = wp )
+                ibit7 = REAL( IBITS(advc_flag(k,j,i),7,1), KIND = wp )
+                ibit6 = REAL( IBITS(advc_flag(k,j,i),6,1), KIND = wp )
 
                 k_ppp = k + 3 * ibit8
